/*
   external-function-definitions
*/

/* include something here to have type pid_t defined */
#include <unistd.h>
#include <sys/types.h>

void load_langfile(gchar *filename);
void load_helpfile(gchar *filename);
gchar *text(gint string_id);
gchar *help(gint string_id);
void scan_lang();

/* gint show_dialog(gchar **icon_xpm, gchar *text, gchar *btn1, gchar *btn2, gchar *btn3, gint defbutton);  */
gint show_dialog(gchar *icon_file, gchar *text, gchar *btn1, gchar *btn2, gchar *btn3, gint defbutton); 
void define_tooltip(GtkWidget *widget, gchar *text);
void clear_sidespace();
void clear_workspace();
void clear_actionspace();

gint init(gint argc, gchar *argv[]);
void create_main(gint confignotloaded);
void create_setup();
void create_duplicate();
void create_create();
void set_font_and_color(GtkWidget *widget, gchar *font, gchar *color);
void set_clist_row_font(GtkCList *clist, gint row, gchar *ffont);
void free_glist(GList **list);
void copy_glist(GList **dst, GList *src);

void get_scsi_type_string(gchar *str, gint type, gint removeable);
void scanbus();
void scandrivers();
GList *get_dsp_devices();
gchar *gen_mix_from_dspdev(gchar *dsp, gchar *ret);
gchar *get_uname_info(gchar *str);
gint save_setup_config(gchar *fname);
gint load_setup_config(gchar *fname);
void get_cd_toc(gint devnr);
void get_cd_toc_and_volid(gint devnr);
pid_t full_dpl_pipe_shell(gint *out, gint *in, gchar *cmd);
pid_t full_dpl_pipe3(gint *out, gint *in, gint *err, gchar *cmd);
void full_dpl_pipe4(pid_t *pidnr1, pid_t *pidnr2, gint *in1, gint *err1,
                    gchar *cmd, gint *out2, gint *err2, gchar *cmd2);
gint query_mixer();
gint set_mixer(gint val);
void kill_readcdda();
gint read_audio_track(gint devnr, gint starttrack, gint endtrack, gint kbyte,
                      gchar *fname, gint startoffset, gint endoffset,
                      gint nrtracks, gfloat percent, gfloat percent_done);
gint read_data_track(gint devnr, gint starttrack, gint kbyte,                               	      gchar *fname, gint startoffset, gint endoffset,
                      gint nrtracks, gfloat percent, gfloat percent_done);
gint verify_audio_track(gint devnr, gint starttrack, gint endtrack, gint kbyte,
                      gchar *fname, gint startoffset, gint endoffset,
                      gint nrtracks, gfloat percent, gfloat percent_done);
gint verify_data_track(gint devnr, gint starttrack, gint kbyte,                               	      gchar *fname, gint startoffset, gint endoffset,
                      gint nrtracks, gfloat percent, gfloat percent_done);

gint check_medium_loaded(gint devnr);
gint check_iso_file(gint devnr, gchar *isoname, gchar *volid, gint startsec);
gint save_text2file(char *fname, GtkWidget *txt);
gint write_copy_cd_toc_file(gchar *tocfile);
gint read_copy_cd_toc_file(gchar *tocfile);
gint write_inf_file(track_read_param_t *trackparam);
gint get_inf_tracktitle(gchar *path, image_files_t *entry);
void fill_device_info(gint devnr, GtkWidget *txt);
void eject_cd(gint devnr);
void get_atip_info(gint devnr, GtkWidget *txt);
void scanblankmodes();
gint read_info_sector_from_file(gchar *isoname, gchar *buf, gint bsize);
gint read_info_sector_from_dev(gint devnr, gchar *buf, gint bsize, gint startsector);
gint start_blanking_process(gint devnr, GtkWidget *text_window);
gint start_write_action(gint devnr);
gint start_write_onthefly_action(gint read_devnr, gint write_devnr);
gint start_delete_action(GList *delfiles);
gint start_cddb_lookup_action();
gint continue_cddb_lookup_action(gint match);
void test_dspdevice_play();

gint get_free_space(gchar *path, gchar *filesystem);
gint convert_devnr2devstring(gint devnr, gchar *str);
gint convert_devnr2vendor(gint devnr, gchar *str);
gint convert_devnr2model(gint devnr, gchar *str);
gint convert_devnr2busid(gint devnr, gchar *str);
void convert_kbytes2mbminstring(gint kbytes, gchar *str);
void convert_kbytes2mbstring(gint kbytes, gchar *str);
void convert_frames2mbstring(gint frames, gchar *str);
void convert_frames2minstring(gint frames, gchar *str);
gint is_directory(gchar *path);
gint is_subdirs(gchar *path);
void show_dir_tree(gchar *retvalue);
GtkWidget *rightjust_gtk_label_new(gchar *txt);
GtkWidget *leftjust_gtk_label_new(gchar *txt);
void show_file_selector(gchar *defname, gchar *retvalue);
gchar *strip_string(gchar *str);
gchar *escape_parse(gchar *str);
gchar *convert_escape(gchar *str);
gint remove_illegal_chars(gchar *str);
gint decode_title_artist(gchar *str, gchar *title, gchar *artist);
gint show_cddb_query();
gint scan_imagedirs();
gint determine_cd_type(gchar *ret, gint mode);
gint determine_free_space(gint *biggestfree);
gint read_line(gint fd, gchar *ptr, gint maxlen);
gint allocate_track_filenames(gint *overwrite, gint *overwritebiggest);
gint scan_for_toc_files();

gint show_and_do_read_tracks(gint devnr);
void show_device_detail(gint devnr);
void display_atip_info(gint devnr);
void wait_and_process_events();
void display_blank_cdrw(gint devnr);
gint check_write_files();
gint show_and_do_write_tracks(gint devnr, gint read_devnr, gint onthefly);
glong get_size_from_imagelist(gchar *tname);
gint get_type_from_imagelist(gchar *tname);
gint show_and_do_delete(GList *delfiles);
gint show_and_do_verify_tracks(gint devnr);
void show_setup_dsptest();
gint extract_quoted(gchar *str);
gint read_line2(gint fd, gchar *ptr, gint maxlen, gint timeout);
gint writen(gint fd, gchar *ptr, gint nbytes, gint newline);
gint check_wav_file(gchar *wavname);
gchar *check_tilde(gchar *str);

void wavplay_frontend(GtkWidget *widget);
void wavplay_dodouble();

gint is_std_wav_file(guchar *hdr);
gint is_in_cd_quality(guchar *hdr);

void dodebug(gint debuglevel, gchar *fmt, ...);
void dolog(gint loglevel, gchar *fmt, ...);
void dobeep(gint type);
gint verify_loaded_config();
gint verify_loaded_config2();

