/*
	menus.c
	27.3.99 tn
*/

#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <dirent.h>
#include <fcntl.h>
#include <sys/types.h>
#include <errno.h>
#include <ctype.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk_imlib.h>
#include "xcdroast.h"
#include "main.h"
#include "xpms/treefolderopen.xpm"
#include "xpms/treefolderclosed.xpm"

extern gint debug;
extern GtkWidget *toplevel;
extern GtkWidget *splitspace;
extern GtkWidget *sidespace;
extern GtkWidget *workspace;
extern GtkWidget *actionspace;
extern scsi_devices_t **scsidevices;
extern writer_driver_t **blankmodes;
extern setup_data_t setupdata;
extern cd_info_t cdinfo;
extern track_info_t **trackinfo;
extern GList *imagelist;
extern current_set_t curset;
extern track_read_set_t trackreadset;
extern gint read_done;
extern GList *tocfiles;
extern gint read_abort_mark;
extern gchar sharedir[MAXLINE];

GtkWidget *ctree_window;
GtkWidget *ctree_entry;
GtkWidget *ctree_okbutton;
GtkWidget *cddb_info_label;
GtkWidget *cddb_info_okbutton;
GtkWidget *cddb_window;
GtkCList *cddb_clist;
GtkWidget *readtrack_info_label, *readtrack_textview, *readtrack_button;
GtkWidget *readtrack_pbar1, *readtrack_pbar2, *readtrack_savebutton;
GtkWidget *readtrack_pbar3;
GtkWidget *readtrack_small_info, *readtrack_small_info2, *readtrack_info_tbl;
GtkWidget *readtrack_info_frame;
GdkPixmap *pixmap1, *pixmap2;
GdkBitmap *mask1, *mask2;
GtkWidget *viewmode_scrolled;
GtkWidget *viewmode_dialog;
GtkWidget *blank_infolabel;
GtkWidget *blank_text_window;
gint dialog_done, dialog_done2, dialog_done3;
gint misc_timer;


gint dialog_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data) {

	dialog_done = -1;
        return(TRUE);
}

gint dialog_delete_event2(GtkWidget *widget, GdkEvent *event, gpointer data) {

	dialog_done2 = -1;
        return(TRUE);
}

gint dialog_delete_event3(GtkWidget *widget, GdkEvent *event, gpointer data) {

	dialog_done3 = -1;
        return(TRUE);
}

void dialog_btn_press(GtkWidget *widget, gint data) {

	dialog_done = data;
}


/* popup a modal window, set cursor to watch, return button pressed
   or -1 when delete_event found.
   Up to three buttons. Set unused buttons to NULL 
   Centers automatically above the toplevel-widow 
   if no toplevel window available center on display
*/

/* gint show_dialog(gchar **icon_xpm, gchar *ttext, gchar *btn1, gchar *btn2, gchar *btn3, gint defbutton) { */
gint show_dialog(gchar *icon_file, gchar *ttext, gchar *btn1, gchar *btn2, gchar *btn3, gint defbutton) {
GtkWidget *dialog;
GtkWidget *button1;
GtkWidget *button2;
GtkWidget *button3;
GtkWidget *box1,*box2;
GtkWidget *b1_t,*b1_sep,*pix,*lab;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GdkPixmap *pixmap;
GdkBitmap *mask;
/* GtkStyle *style; */
GtkRequisition rq;
GdkWindowAttr *win_attr;
gint w,h;
GdkImlibImage *im;
gchar tmp[MAXLINE];

	/* if another dialog is running, ignore */
	if (dialog_done == 999) {
		return -1;
	}

	dodebug(8, "displaying show_dialog: %s\n", ttext);

	/* mark our dialog as running */
	dialog_done = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (dialog_delete_event), (gpointer) dialog);


	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,0);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

        b1_t = gtk_table_new(1,10, TRUE);
	gtk_container_border_width(GTK_CONTAINER(b1_t),10);

        gtk_box_pack_start(GTK_BOX(box1),b1_t,FALSE,TRUE,10);

	/* realize table to be able to put a pixmap in it */
        gtk_widget_realize(b1_t);

/*        style = gtk_widget_get_style(b1_t);
        pixmap = gdk_pixmap_create_from_xpm_d(b1_t->window, &mask,
                 &style->bg[GTK_STATE_NORMAL],(gchar **)icon_xpm);
*/
	g_snprintf(tmp,MAXLINE,"%s/%s", sharedir,icon_file);
	im=gdk_imlib_load_image(tmp);
	w=im->rgb_width;
	h=im->rgb_height;
	gdk_imlib_render(im,w,h);
	pixmap = gdk_imlib_move_image(im);
	mask = gdk_imlib_move_mask(im);
        pix = gtk_pixmap_new(pixmap,mask);
        gtk_table_attach_defaults(GTK_TABLE(b1_t), pix, 0,2,0,1);

        lab = gtk_label_new(ttext);
        gtk_table_attach_defaults(GTK_TABLE(b1_t), lab, 2,10,0,1);

        b1_sep = gtk_hseparator_new();
        gtk_box_pack_start(GTK_BOX(box1),b1_sep,FALSE,TRUE,0);

        box2 = gtk_hbox_new(FALSE,0);
        gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,10);

	if (btn1 != NULL) {
        	button1 = gtk_button_new_with_label (btn1);
		gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
		gtk_widget_show(button1);
		gtk_signal_connect(GTK_OBJECT(button1),"clicked",
			GTK_SIGNAL_FUNC(dialog_btn_press), (gpointer) 0);
		GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
		if (defbutton == 0) gtk_widget_grab_default (button1);
	}
	if (btn2 != NULL) {
        	button2 = gtk_button_new_with_label (btn2);
		gtk_box_pack_start(GTK_BOX(box2),button2,TRUE,TRUE,10);
		gtk_widget_show(button2);
		gtk_signal_connect(GTK_OBJECT(button2),"clicked",
			GTK_SIGNAL_FUNC(dialog_btn_press), (gpointer) 1);
		GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
		if (defbutton == 1) gtk_widget_grab_default (button2);
	}
	if (btn3 != NULL) {
        	button3 = gtk_button_new_with_label (btn3);
		gtk_box_pack_start(GTK_BOX(box2),button3,TRUE,TRUE,10);
		gtk_widget_show(button3);
		gtk_signal_connect(GTK_OBJECT(button3),"clicked",
			GTK_SIGNAL_FUNC(dialog_btn_press), (gpointer) 2);
		GTK_WIDGET_SET_FLAGS (button3, GTK_CAN_DEFAULT);
		if (defbutton == 2) gtk_widget_grab_default (button3);
	}

        gtk_widget_show(box2);
        gtk_widget_show(b1_sep);
        gtk_widget_show(pix);
        gtk_widget_show(lab);
        gtk_widget_show(b1_t);
        gtk_widget_show(box1);

	/* grab cursor and change to watch */
	if (GTK_WIDGET_MAPPED(toplevel)) {
        	gtk_grab_add(dialog);
		gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
		normal_cursor = win_attr->cursor;
        	cursor = gdk_cursor_new(GDK_WATCH);
        	gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);
	}

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	} else {
		/* otherwise center in screen */
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
		xsize = gdk_screen_width();
		ysize = gdk_screen_height();
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xsize/2-rq.width/2,ysize/2-rq.height/2);
		
	}

	gtk_widget_show(dialog);

	/* if this is a warning sound bell (if requested in setup) */
	if (strcmp(icon_file, ICO_WARN) == 0) {
		dobeep(2);
	}

	/* now wait until button is pressed */
	while (dialog_done == 999) {
		wait_and_process_events();
	}

	if (GTK_WIDGET_MAPPED(toplevel)) {
        	gtk_grab_remove(GTK_WIDGET(dialog));
        	gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);
	}

	/* remove dialog window */
        gtk_widget_destroy(dialog);

	return dialog_done; 
}


/* clears the left sidebar */

void clear_sidespace() {

	gtk_widget_destroy(sidespace);
	sidespace = gtk_vbox_new(FALSE,0);
	gtk_paned_add1(GTK_PANED(splitspace), sidespace);
	gtk_widget_set_usize(sidespace,150,0);
}


/* clears the right workspace */

void clear_workspace() {

	gtk_widget_destroy(workspace);
	workspace = gtk_vbox_new(FALSE,0);
	gtk_paned_add2(GTK_PANED(splitspace), workspace);
}


/* clears the actionspace subwindow */

void clear_actionspace() {

	gtk_widget_destroy(actionspace);
	actionspace = gtk_vbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(workspace), actionspace,TRUE,TRUE,10);

	/* strange, why we need that...*/
	while (gtk_events_pending())
		gtk_main_iteration();

}


/* add subdirectory nodes to an existing ctree */

void ctree_add_dir_nodes(gchar *path, GtkCTree *ctree, GtkCTreeNode *parent) {
struct dirent *ent;
DIR *dir;         
gchar *text[1];
gchar tmp[MAXLINE];
GtkCTreeNode *sibling;
gchar *textdata, *str1, *str2, *str3;
GList *dir_list, *first, *last, *list1, *list2;

	dir_list = NULL;
	dir = opendir(path);

	/* invalid directory */
	if (dir == NULL) 
		return;

	/* read entries */
	while ( (ent = readdir(dir)) ) {

		if (strcmp(ent->d_name,".") == 0 || 
		    strcmp(ent->d_name,"..") == 0) 
			continue;

		strcpy(tmp,path);
		/* add slash when not there */
		if (tmp[strlen(tmp)-1] != '/')  
			strcat(tmp,"/");
		strcat(tmp,ent->d_name);

		/* add only directories */
		if (is_directory(tmp) == 1) {

			dir_list = g_list_append(dir_list, g_strdup(ent->d_name));
		}
	}
	closedir(dir);

	/* sort the directory-list */
	if (dir_list == NULL)
		return;

	first = g_list_first(dir_list);
	last = g_list_last(dir_list);
	for (list1 = first; list1 != last; list1 = list1->next) {
		for (list2 = last; list2 != list1; list2 = list2->prev) {
			str1 = (gchar *) list1->data;
			str2 = (gchar *) list2->data;

			if (strcmp (str1, str2) > 0) {
				str3 = str1;
				list1->data = list2->data;
				list2->data = str3;
			}
		}
	}


	/* draw entries */
	while (dir_list) {
		/* allocate directory names */
		text[0] = dir_list->data;
		strcpy(tmp,path);
		/* add slash when not there */
		if (tmp[strlen(tmp)-1] != '/')  
			strcat(tmp,"/");
		strcat(tmp,dir_list->data);
		textdata = g_strdup(tmp);

		/* now check if there are subdirs in that dir */
		if (is_subdirs(tmp)) {
			sibling = gtk_ctree_insert_node (ctree,parent,
				NULL,text,3,pixmap1,mask1,
				pixmap2,mask2,FALSE,FALSE);

			/* create empty node */
			gtk_ctree_insert_node (ctree,sibling,
				NULL,NULL,3,NULL,NULL,NULL,NULL,FALSE,FALSE);

		} else {
			/* no subdirs */
			sibling = gtk_ctree_insert_node (ctree,parent,
				NULL,text,3,pixmap1,mask1,
				pixmap2,mask2,TRUE,FALSE);
		}

		/* save the full path name in the node-data */
		gtk_ctree_node_set_row_data(ctree,sibling,textdata); 

		dir_list = dir_list->next;
	}

	/* free list */
	free_glist(&dir_list);
}

	
/* remove all children of a node in a ctree */

void ctree_remove_children(GtkCTree * tree, GtkCTreeNode * node) {
GtkCTreeNode *child;
GList *sibling_list;
gchar *strpnt;

	/* Get the child node and make sure it's not NULL. */
	child = GTK_CTREE_ROW (node)->children;
	if (child == NULL)
		return;

	/* Get the list of siblings. */
	sibling_list = NULL;
	for (; child; child = GTK_CTREE_ROW (child)->sibling)
		sibling_list = g_list_append (sibling_list, child);

  	/* Remove all of the sibling nodes. */
	gtk_clist_freeze (GTK_CLIST (tree));
	for (; sibling_list; sibling_list = sibling_list->next) {
	
		/* free allocated node-data */
		strpnt = gtk_ctree_node_get_row_data (tree, 
			GTK_CTREE_NODE (sibling_list->data));
		g_free(strpnt);

		gtk_ctree_remove_node (tree, 
			GTK_CTREE_NODE (sibling_list->data));
		
	}
	gtk_clist_thaw (GTK_CLIST (tree));

	/* Free up memory. */
	g_list_free (sibling_list);

}


/* called when the users expands a directory in the ctree */

gint ctree_expand (GtkCTree *tree, GtkCTreeNode *node, gpointer data) {
gchar *newdir;
GdkCursor *normal_cursor, *clock_cursor;
GdkWindowAttr *win_attr;

	/* fetch full path the node stands for */
	newdir = gtk_ctree_node_get_row_data (tree, node);

	/* skip root-dir */
	if (newdir == NULL) return TRUE;

	/* Change cursor to clock */
	gdk_window_get_user_data (GTK_WIDGET (ctree_window)->window,
			(gpointer) &win_attr);

	/* Why does this cause a core dump? 
	   Bug in GTK I guess...workaround is to allocate a new cursor 
	normal_cursor = win_attr->cursor; 
	*/
	normal_cursor = gdk_cursor_new (GDK_TOP_LEFT_ARROW);
	clock_cursor = gdk_cursor_new (GDK_WATCH);
	gdk_window_set_cursor (GTK_WIDGET (ctree_window)->window, clock_cursor);

	/* gives gtk a break and time to update REALLY the cursor */
	/* I dont think this slowes things down */
	gtk_main_iteration_do(FALSE);

	gtk_clist_freeze (GTK_CLIST (tree));

	/* remove first everything and then add new nodes */
	ctree_remove_children(tree,node);
	ctree_add_dir_nodes(newdir,tree,node);

	/* unfreeze and change cursor back */
	gtk_clist_thaw (GTK_CLIST (tree));
	gdk_window_set_cursor (GTK_WIDGET (ctree_window)->window, normal_cursor);

	return TRUE;
}


/* called when the user selects a row in a ctree */

gint ctree_select_row (GtkCTree *tree, GtkCTreeNode *node, gpointer data) {
gchar *pnt;

	pnt = gtk_ctree_node_get_row_data (tree, node);
	if (pnt == NULL) {
		/* no path set */
		gtk_entry_set_text(GTK_ENTRY(ctree_entry),"");
		gtk_widget_set_sensitive(ctree_okbutton,FALSE);
	} else {
		gtk_entry_set_text(GTK_ENTRY(ctree_entry),pnt);
		gtk_widget_set_sensitive(ctree_okbutton,TRUE);
	}

	return TRUE;
}


/* creates a ctree for directory browsing */
 
GtkCTree *create_directory_ctree(gchar *basedir,gchar *title, GtkWidget *win, GtkWidget *entry) {
gchar tmp[MAXLINE];
GtkCTree *ctree;
GtkCTreeNode *parent;
gchar *titles[1];
gchar *text[1];
GtkStyle *style;

	/* save the parent window for cursor handling */
	ctree_window = win;
	ctree_entry = entry;

	/* do we want a title? */
	if (title == NULL) {
		ctree = GTK_CTREE (gtk_ctree_new (1, 0));
	} else {
		titles[0] = title;
		ctree = GTK_CTREE (gtk_ctree_new_with_titles (1, 0, titles));
	}	
	gtk_clist_set_row_height(GTK_CLIST(ctree),16);

	/* create folder pixmaps */
	style = gtk_widget_get_style(GTK_WIDGET(ctree));
	pixmap1 = gdk_pixmap_create_from_xpm_d(win->window,
		&mask1,&style->bg[GTK_STATE_NORMAL],
		(gchar **) treefolderclosed_xpm);
	pixmap2 = gdk_pixmap_create_from_xpm_d(win->window,
		&mask2,&style->bg[GTK_STATE_NORMAL],
		(gchar **) treefolderopen_xpm);

	/* connect our signal stuff */
	gtk_signal_connect(GTK_OBJECT(ctree),"tree_expand",
				GTK_SIGNAL_FUNC(ctree_expand),NULL);
	gtk_signal_connect(GTK_OBJECT(ctree),"tree_select_row",
				GTK_SIGNAL_FUNC(ctree_select_row),NULL);

	/* make root entry in clist */
	strcpy(tmp,basedir); text[0]=tmp;
	parent = gtk_ctree_insert_node (ctree,NULL,
		NULL,text,3,pixmap1,mask1,pixmap2,mask2,FALSE,TRUE);

	ctree_add_dir_nodes(basedir,ctree,parent);

	return ctree;
}


void show_dir_btn_press(GtkWidget *widget, gint data) {

	dialog_done = data;
}


/* popup a modal window, set cursor to watch, return path or NULL-string 
   when cancel or delete_event found.
   Centers automatically above the toplevel-widow 
*/

void show_dir_tree(gchar *retvalue) {
GtkWidget *dialog;
GtkWidget *button1;
GtkWidget *button2;
GtkWidget *box1,*box2,*box3;
GtkWidget *entry1,*b1_sep;
GtkWidget *scrolled_win;
GtkCTree *ctree;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;

	/* if another dialog is running, ignore */
	if (dialog_done == 999) {
		return;
	}

	dodebug(8, "displaying show_dir_tree\n");

	/* mark our dialog as running */
	dialog_done = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,350,300); 
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (dialog_delete_event), (gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,0);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(box1),scrolled_win,TRUE,TRUE,0);
	gtk_widget_realize(scrolled_win);
	gtk_widget_show(scrolled_win);
	
	box3 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box3,FALSE,TRUE,10);
	entry1 = gtk_entry_new();
	gtk_entry_set_editable(GTK_ENTRY(entry1),FALSE);
	gtk_box_pack_start(GTK_BOX(box3),entry1,TRUE,TRUE,10);
	gtk_widget_show(entry1);

	ctree = create_directory_ctree("/",text(84),dialog,entry1);
 
	gtk_container_add (GTK_CONTAINER (scrolled_win), GTK_WIDGET (ctree));
	gtk_widget_show( GTK_WIDGET (ctree));

	gtk_widget_show(box3);
	gtk_widget_show(box1);

	b1_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1),b1_sep,FALSE,TRUE,0);
	gtk_widget_show(b1_sep);

	box2 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,10);
	gtk_widget_show(box2);

	button1 = gtk_button_new_with_label(T_OK);
	ctree_okbutton = button1;
	gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
	gtk_widget_set_sensitive(button1,FALSE);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(show_dir_btn_press), (gpointer) 0);

	button2 = gtk_button_new_with_label(T_CANCEL);
	gtk_box_pack_start(GTK_BOX(box2),button2,TRUE,TRUE,10);
	gtk_widget_show(button2);
	GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (button2);
	gtk_signal_connect(GTK_OBJECT(button2),"clicked",
		GTK_SIGNAL_FUNC(show_dir_btn_press), (gpointer) -1);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	gtk_widget_show(dialog);


	/* now wait until button is pressed */
	while (dialog_done == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	if (dialog_done != -1) {
		strcpy(retvalue,gtk_entry_get_text(GTK_ENTRY(entry1)));
	} else {
		/* cancel or delete_event */
		strcpy(retvalue,"");
	}	

	/* remove dialog window */
        gtk_widget_destroy(dialog);
}


/* fileselector-box ok-button callback */

void file_selector_ok(GtkWidget *widget, GtkFileSelection *fs) {

	dialog_done3 = 1;
}


/* display a file-selector box with defname preselected. Return "" 
   or filename in retvalue */

void show_file_selector(gchar *defname, gchar *retvalue) {
GtkWidget *dialog;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;
GtkButton *b1;
GtkCList *dirs;

	/* if another dialog is running, ignore */
	if (dialog_done3 == 999) {
		return;
	}

	dodebug(8, "displaying show_fileselector\n");

	/* mark our dialog as running */
	dialog_done3 = 999;

	/* create new window and position it relative to the main window */
	dialog = gtk_file_selection_new (text(83));
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

	gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(dialog));
	if (defname != NULL) {
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(dialog),
			defname);
	}

	/* translate the default-texts on the selector */
	b1 = GTK_BUTTON(GTK_FILE_SELECTION(dialog)->ok_button);
	gtk_label_set_text(GTK_LABEL(b1->child),T_OK);
	b1 = GTK_BUTTON(GTK_FILE_SELECTION(dialog)->cancel_button);
	gtk_label_set_text(GTK_LABEL(b1->child),T_CANCEL);
	dirs = GTK_CLIST(GTK_FILE_SELECTION(dialog)->dir_list);
	gtk_clist_set_column_title(dirs,0,text(85)); 
	dirs = GTK_CLIST(GTK_FILE_SELECTION(dialog)->file_list);
	gtk_clist_set_column_title(dirs,0,text(86)); 

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (dialog_delete_event3), dialog);

        gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(dialog)->ok_button),
		"clicked", GTK_SIGNAL_FUNC(file_selector_ok), dialog);

        gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(dialog)->cancel_button),
		"clicked", GTK_SIGNAL_FUNC(dialog_delete_event3), dialog);
	

	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	/* center does not work with gtk-1.2.1, but ok with 1.2.3, well
	   what the heck... */

	gtk_widget_show(dialog);


	/* now wait until button is pressed */
	while (dialog_done3 == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	if (dialog_done3 != -1) {
		strcpy(retvalue,gtk_file_selection_get_filename (GTK_FILE_SELECTION (dialog)));
	} else {
		/* cancel or delete_event */
		strcpy(retvalue,"");
	}	

	/* remove dialog window */
        gtk_widget_destroy(dialog);
}


/* what to do when user selects a CD from the database */

void cddb_select_row(GtkWidget *clist, gint row, gint col,
		     GdkEventButton *event, gpointer data) {

	/* we selected something, unlook ok-button */
	gtk_widget_set_sensitive(cddb_info_okbutton,TRUE);

	/* got double-click? Simulate ok-button-press */
	if (event && event->type == GDK_2BUTTON_PRESS) {
		gtk_button_clicked(GTK_BUTTON(cddb_info_okbutton));
	}
}


/* called from cancel or ok button */
 
void show_cddb_btn_press(GtkWidget *widget, gint data) {
GList *sel;
gint row;

	/* cancel event */
	if (data == -1) {
		if (read_done == 999) {
			/* abort our cddb-process */
			kill_readcdda();
		}
		dialog_done = -1;
		return;
	}

	/* ok button pressed - find out which entry was selected */
	sel = cddb_clist->selection;
	if (sel != NULL) {
		row = GPOINTER_TO_INT(sel->data);
		/* now go back to network code and fetch fitting CD */
		if (continue_cddb_lookup_action(row) != 0) {
			/* disable ok-button */
			gtk_widget_set_sensitive(cddb_info_okbutton,FALSE);
		} else {
			/* data ok received */
			dialog_done = 0;
		}
	}
}


/* called when somebody closes the cddb-window via window-manager */

gint dialog_cddb_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data) {

	if (read_done == 999) {
		/* abort our cddb-process */
		kill_readcdda();
	}
	dialog_done = -1;
	return(TRUE);
}


/* popup a modal window, set cursor to watch, return 0 if correct
   data was received from cddb-server, -1 if not or 
   when cancel or delete_event found.
   Centers automatically above the toplevel-widow 
*/

gint show_cddb_query() {
GtkWidget *dialog;
GtkWidget *button1;
GtkWidget *button2;
GtkWidget *box1,*box2,*hbox;
GtkWidget *f1, *cddb_logo;
GdkPixmap *p;
GdkBitmap *m;
GdkImlibImage *im;
gint w,h;
GtkWidget *b1_sep, *lbl;
GtkWidget *scrolled_win, *c_list;
GtkCList *clist;
gchar *titles[1];
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;
gchar tmp[MAXLINE];

	/* if another dialog is running, ignore */
	if (dialog_done == 999) {
		return -1;
	}

	dodebug(8, "displaying show_cddb_query\n");

	/* mark our dialog as running */
	dialog_done = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,450,260);
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));
	cddb_window = dialog;

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (dialog_cddb_delete_event), (gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,5);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	hbox = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),hbox,FALSE,TRUE,5);
	gtk_widget_show(hbox);

	f1 = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(f1),GTK_SHADOW_IN);
	gtk_box_pack_start(GTK_BOX(hbox),f1,TRUE,TRUE,5);
	gtk_widget_show(f1);

	lbl = gtk_label_new("");
	cddb_info_label = lbl;
	gtk_container_add(GTK_CONTAINER(f1), lbl);
	gtk_misc_set_alignment(GTK_MISC(lbl),0.0,0.5);
	gtk_misc_set_padding(GTK_MISC(lbl),10,0);
	gtk_widget_show(lbl);

	/* load a gif-image and put into a pixmap */
	g_snprintf(tmp,MAXLINE,"%s/%s", sharedir,CDDBLOGO);
	im=gdk_imlib_load_image(tmp);
	w=im->rgb_width;
	h=im->rgb_height;
	gdk_imlib_render(im,w,h);
	p=gdk_imlib_move_image(im);
	m=gdk_imlib_move_mask(im);
	cddb_logo = gtk_pixmap_new(p,m);

	gtk_box_pack_start(GTK_BOX(hbox),cddb_logo,FALSE,FALSE,5);
	gtk_widget_show(cddb_logo);
	
	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(box1),scrolled_win,TRUE,TRUE,0);
	gtk_widget_show(scrolled_win);
	
	titles[0] = text(108);
	c_list = gtk_clist_new_with_titles(1,titles);
	clist = GTK_CLIST(c_list);
	cddb_clist = clist;
	gtk_clist_set_column_auto_resize(clist, 0, TRUE);
	gtk_container_add (GTK_CONTAINER (scrolled_win), c_list);
	gtk_widget_show(c_list);
	gtk_signal_connect(GTK_OBJECT(clist), "select_row",
		GTK_SIGNAL_FUNC(cddb_select_row), NULL); 

	gtk_widget_show(box1);

	b1_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1),b1_sep,FALSE,TRUE,0);
	gtk_widget_show(b1_sep);

	box2 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,10);
	gtk_widget_show(box2);

	button1 = gtk_button_new_with_label(T_OK);
	cddb_info_okbutton = button1;
	gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
	gtk_widget_set_sensitive(button1,FALSE);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(show_cddb_btn_press), (gpointer) 0);

	button2 = gtk_button_new_with_label(T_CANCEL);
	gtk_box_pack_start(GTK_BOX(box2),button2,TRUE,TRUE,10);
	gtk_widget_show(button2);
	GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (button2);
	gtk_signal_connect(GTK_OBJECT(button2),"clicked",
		GTK_SIGNAL_FUNC(show_cddb_btn_press), (gpointer) -1);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	gtk_widget_show(dialog);


	/* lets do some work */
	start_cddb_lookup_action();

	/* now wait until button is pressed */
	while (dialog_done == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);

	return dialog_done;
}


/* start the read-processes according to the trackreadset-struct.
   Update read-dialogbox and return 0 if ok, 1 on error */ 

gint start_read_action(gint read_devnr) {
GList *loop;
track_read_param_t *trackparam;
gfloat percent_done;
gint stat;

	dolog(1, "Reading CD with toc file %s\n", trackreadset.tocfile);

	percent_done = 0;

	/* start reading all tracks */
	loop = g_list_first(trackreadset.trackparams);
	while (loop) {
		trackparam = loop->data;
		
		/* data-track */
		if (trackparam->tracktype == 0) {
			stat = read_data_track(read_devnr,
				trackparam->starttrack,
				trackparam->kbyte,
				trackparam->trackfile,
				trackparam->startoffset,	
				trackparam->endoffset,
				trackreadset.nrtracks,				
				trackparam->percent,
				percent_done);
		} else {
		/* audio-track */
			stat = read_audio_track(read_devnr,
				trackparam->starttrack,
				trackparam->endtrack,
				trackparam->kbyte,
				trackparam->trackfile,
				trackparam->startoffset,
				trackparam->endoffset,
				trackreadset.nrtracks,				
				trackparam->percent,
				percent_done);
		}
		if (stat == 0) {
			/* no error */
			percent_done += trackparam->percent;

			/* write inf-file */
			write_inf_file(trackparam); 
		} else {
			/* error while reading */
			return 1;
		}
		loop = loop->next;
	}

	/* save the toc file */
	write_copy_cd_toc_file(trackreadset.tocfile);

	/* unset current active toc-file */
	g_free(curset.tocfile);
	curset.tocfile = g_strdup("");

	/* no error reading tracks */
	gtk_label_set_text(GTK_LABEL(readtrack_info_label), text(161));
	gtk_label_set_text(GTK_LABEL(readtrack_small_info), text(165));

	/* update image-dir-lists */
	scan_imagedirs();

	return 0;
}


/* called from cancel or ok button */
 
void show_readtrack_btn_press(GtkWidget *widget, gint data) {

	/* read-process running? */
	if (read_done == 999) {
		read_abort_mark = 1;
		/* abort our read-process */
		kill_readcdda();
		return;
	}

	/* cancel event */
	if (data == -1) {
		dialog_done = -1;
		return;
	}
}

void show_readtrack_save_press(GtkWidget *widget, gint data) {
char tmp[MAXLINE];

	/* show fileselector */
	show_file_selector(SAVEREADTRACKS,tmp);
	
	/* not cancel pressed? */
	if (strcmp(tmp,"") != 0) {
		if (save_text2file(tmp, readtrack_textview) == 0) {
			show_dialog(ICO_INFO,text(270), T_OK, NULL, NULL, 0);
		}
	}
}

gint readtrack_dialog_delete_event(GtkWidget *widget, GdkEvent *event, 
	gpointer data) {

	/* read-process running? */
	if (read_done == 999) {
		read_abort_mark = 1;
		/* abort our read-process */
		kill_readcdda();
		return(TRUE);
	}

	dialog_done = -1;
        return(TRUE);
}


/* change the read-tracks menu according to view-setting */
void viewmode_selected(GtkWidget *item, gint val) {
	
	curset.proc_view = val;

	gtk_window_set_policy(GTK_WINDOW(viewmode_dialog), FALSE, TRUE, TRUE );
	if (val == 2) {
		/* extended view */
		gtk_widget_show(readtrack_info_frame);
		gtk_widget_show(readtrack_info_tbl);
		gtk_widget_show(viewmode_scrolled);
		gtk_widget_show(readtrack_savebutton);
		gtk_widget_hide(readtrack_small_info);
		gtk_widget_hide(readtrack_small_info2);
	} else if (val == 1) {
		/* normal view */
		gtk_widget_show(readtrack_info_frame);
		gtk_widget_show(readtrack_info_tbl);
		gtk_widget_hide(viewmode_scrolled);
		gtk_widget_hide(readtrack_savebutton);
		gtk_widget_hide(readtrack_small_info);
		gtk_widget_hide(readtrack_small_info2);
	} else {
		/* small view */
		gtk_widget_hide(readtrack_info_frame);
		gtk_widget_hide(readtrack_info_tbl);
		gtk_widget_hide(viewmode_scrolled);
		gtk_widget_hide(readtrack_savebutton);
		gtk_widget_show(readtrack_small_info);
		gtk_widget_show(readtrack_small_info2);
	}

	while (gtk_events_pending())
		gtk_main_iteration();

	gtk_window_set_policy(GTK_WINDOW(viewmode_dialog), FALSE, TRUE, FALSE);
}


/* popup a modal window, set cursor to watch, trigger read tracks 
   and return 0 if all ok, -1 if not or 
   when cancel or delete_event found.
   Centers automatically above the toplevel-widow 
*/

gint show_and_do_read_tracks(gint devnr) {
GtkWidget *omenu;
GtkWidget *menu;
GtkWidget *menu_item;
GtkWidget *dialog;
GtkWidget *l1;
GtkWidget *button1, *button2;
GtkWidget *box1,*box2,*txt;
GtkWidget *f1, *tbl;
GtkWidget *b1_sep, *lbl;
GtkWidget *scrolled_win;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;
GtkAdjustment *adj1, *adj2;
GtkWidget *pbar1, *pbar2;
gint i, menuidx, menuhistory;

	/* if another dialog is running, ignore */
	if (dialog_done == 999) {
		return -1;
	}

	dodebug(8, "displaying show_and_do_read_tracks\n");
	
	/* mark our dialog as running */
	dialog_done = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	viewmode_dialog = dialog;
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,340,0);
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (readtrack_dialog_delete_event), 
		(gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,5);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	f1 = gtk_frame_new(NULL);
	readtrack_info_frame = f1;
	gtk_frame_set_shadow_type(GTK_FRAME(f1),GTK_SHADOW_IN);
	gtk_widget_set_usize(f1,0,36);
	gtk_box_pack_start(GTK_BOX(box1),f1,FALSE,TRUE,5);
	if (curset.proc_view > 0) 
		gtk_widget_show(f1);

	lbl = gtk_label_new("");
	readtrack_info_label = lbl;
	gtk_container_add(GTK_CONTAINER(f1), lbl);
	gtk_misc_set_alignment(GTK_MISC(lbl),0.5,0.5);
	gtk_misc_set_padding(GTK_MISC(lbl),10,0);
	gtk_widget_show(lbl);

	tbl = gtk_table_new(2, 10, TRUE);
	readtrack_info_tbl = tbl;
	gtk_table_set_col_spacing(GTK_TABLE(tbl),1,10);
	gtk_table_set_row_spacings(GTK_TABLE(tbl),5);
	gtk_box_pack_start(GTK_BOX(box1),tbl,FALSE,TRUE,5);
	if (curset.proc_view > 0) 
		gtk_widget_show(tbl);

	l1 = rightjust_gtk_label_new(text(150));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,0,2,0,1);
	gtk_widget_show(l1);

	adj1 = (GtkAdjustment *)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
	pbar1 = gtk_progress_bar_new_with_adjustment(adj1);
	readtrack_pbar1 = pbar1;
	gtk_progress_set_format_string(GTK_PROGRESS(pbar1),"%p%%");
	gtk_progress_set_show_text(GTK_PROGRESS(pbar1),TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tbl),pbar1,2,10,0,1);
	gtk_widget_show(pbar1);

	l1 = rightjust_gtk_label_new(text(151));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,0,2,1,2);
	gtk_widget_show(l1);

	adj2 = (GtkAdjustment *)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
	pbar2 = gtk_progress_bar_new_with_adjustment(adj2);
	readtrack_pbar2 = pbar2;
	gtk_progress_set_format_string(GTK_PROGRESS(pbar2),"%p%%");
	gtk_progress_set_show_text(GTK_PROGRESS(pbar2),TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tbl),pbar2,2,10,1,2);
	gtk_widget_show(pbar2);

	tbl = gtk_table_new(1, 10, TRUE);
	gtk_table_set_col_spacing(GTK_TABLE(tbl),6,10);
	gtk_table_set_row_spacings(GTK_TABLE(tbl),5);
	gtk_box_pack_start(GTK_BOX(box1),tbl,FALSE,TRUE,0);
	gtk_widget_show(tbl);

	lbl = gtk_label_new("");
	readtrack_small_info = lbl;
	gtk_table_attach_defaults(GTK_TABLE(tbl),lbl,0,3,0,1);
	if (curset.proc_view == 0) 
		gtk_widget_show(lbl);

	lbl = gtk_label_new("");
	readtrack_small_info2 = lbl;
	gtk_table_attach_defaults(GTK_TABLE(tbl),lbl,3,5,0,1);
	if (curset.proc_view == 0) 
		gtk_widget_show(lbl);

	l1 = rightjust_gtk_label_new(text(152));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,5,7,0,1);
	gtk_widget_show(l1);

	omenu = gtk_option_menu_new();
	menu = gtk_menu_new();
	menuidx = 0; menuhistory = -1;

	for (i=0; i<3; i++) {
		menu_item = gtk_menu_item_new_with_label(text(153+i));
		gtk_signal_connect(GTK_OBJECT(menu_item),
			"activate", GTK_SIGNAL_FUNC(viewmode_selected),
			(gpointer)i);
		gtk_menu_append (GTK_MENU (menu), menu_item);
		if (curset.proc_view == i) { menuhistory = menuidx; }
		menuidx++;
		gtk_widget_show (menu_item);
	}
	gtk_option_menu_set_menu (GTK_OPTION_MENU (omenu), menu);
	if (menuhistory != -1) {
		gtk_option_menu_set_history(GTK_OPTION_MENU (omenu),menuhistory);
	} else {
		curset.proc_view = 1;
		gtk_option_menu_set_history(GTK_OPTION_MENU (omenu),1);
	}
	gtk_table_attach_defaults(GTK_TABLE(tbl),omenu,7,10,0,1);
	gtk_widget_show(omenu);

	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	viewmode_scrolled = scrolled_win;
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(box1),scrolled_win,TRUE,TRUE,0);

	/* show only in extended view */
	if (curset.proc_view == 2) 
		gtk_widget_show(scrolled_win);

	txt = gtk_text_new(NULL,NULL);
	readtrack_textview = txt;
	gtk_text_set_editable(GTK_TEXT(txt),FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(txt),TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_win), txt);
	gtk_widget_show(txt);

	gtk_widget_show(box1);

	b1_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1),b1_sep,FALSE,TRUE,0);
	gtk_widget_show(b1_sep);

	box2 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,10);
	gtk_widget_show(box2);

	button1 = gtk_button_new_with_label(T_CANCEL);
	readtrack_button = button1;
	gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (button1);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(show_readtrack_btn_press), (gpointer) -1);

	button2 = gtk_button_new_with_label(text(162));
	readtrack_savebutton = button2;
	gtk_box_pack_start(GTK_BOX(box2),button2,TRUE,TRUE,10);
	GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(button2),"clicked",
		GTK_SIGNAL_FUNC(show_readtrack_save_press), (gpointer) -1);
	/* show only in extended view */
	if (curset.proc_view == 2) 
		gtk_widget_show(button2);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	gtk_widget_show(dialog);

	/* here is the action */
	start_read_action(devnr);

	/* when done with reading rename button to OK */
	gtk_label_set_text(GTK_LABEL(GTK_BIN(readtrack_button)->child),T_OK);
	
	dobeep(1);

	/* now wait until button is pressed */
	while (dialog_done == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);

	return dialog_done;
}


/* popup a modal window, set cursor to watch, return path or NULL-string 
   when cancel or delete_event found.
   Centers automatically above the toplevel-widow 
*/

void show_device_detail(gint devnr) {
GtkWidget *dialog;
GtkWidget *button1;
GtkWidget *box1,*box2,*txt;
GtkWidget *f1;
GtkWidget *scrolled_win;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;

	/* if another dialog is running, ignore */
	if (dialog_done == 999) {
		return;
	}

	dodebug(8, "displaying show_device_detail\n");

	/* mark our dialog as running */
	dialog_done = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,500,300); 
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (dialog_delete_event), (gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,0);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	f1 = gtk_frame_new(text(166));
	set_font_and_color(f1,BOLDFONT,NULL);
	gtk_box_pack_start(GTK_BOX(box1),f1,TRUE,TRUE,0);
	gtk_widget_show(f1);

	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(f1),scrolled_win);
	gtk_widget_show(scrolled_win);
	
	txt = gtk_text_new(NULL,NULL);
	gtk_text_set_editable(GTK_TEXT(txt),FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(txt),TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_win), txt);
	gtk_widget_show(txt);

	gtk_widget_show(box1);

	box2 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,5);
	gtk_widget_show(box2);

	button1 = gtk_button_new_with_label(T_OK);
	gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(dialog_btn_press), (gpointer) 0);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	/* now fill text-widget with infos */
	fill_device_info(devnr, txt);
	gtk_text_set_point(GTK_TEXT(txt),0);

	gtk_widget_show(dialog);

	/* now wait until button is pressed */
	while (dialog_done == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);
}


/* popup a modal window, set cursor to watch, return path or NULL-string 
   when cancel or delete_event found.
   Centers automatically above the toplevel-widow 
*/

void display_atip_info(gint devnr) {
GtkWidget *dialog;
GtkWidget *button1;
GtkWidget *box1,*box2,*txt;
GtkWidget *f1;
GtkWidget *scrolled_win;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;

	/* if another dialog is running, ignore */
	if (dialog_done == 999) {
		return;
	}

	dodebug(8, "displaying display_atip_info\n");

	/* mark our dialog as running */
	dialog_done = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,400,300); 
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (dialog_delete_event), (gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,0);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	f1 = gtk_frame_new(text(176));
	set_font_and_color(f1,BOLDFONT,NULL);
	gtk_box_pack_start(GTK_BOX(box1),f1,TRUE,TRUE,0);
	gtk_widget_show(f1);

	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(f1),scrolled_win);
	gtk_widget_show(scrolled_win);
	
	txt = gtk_text_new(NULL,NULL);
	gtk_text_set_editable(GTK_TEXT(txt),FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(txt),TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_win), txt);
	gtk_widget_show(txt);

	gtk_widget_show(box1);

	box2 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,5);
	gtk_widget_show(box2);

	button1 = gtk_button_new_with_label(T_OK);
	gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(dialog_btn_press), (gpointer) 0);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	/* now fill text-widget with infos */
	get_atip_info(devnr, txt);
	gtk_text_set_point(GTK_TEXT(txt),0);

	gtk_widget_show(dialog);

	/* now wait until button is pressed */
	while (dialog_done == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);
}


/* callbacks for blank-menu */

void blankmode_selected(GtkWidget *item, gint mode) {

	curset.blankmode = mode;
}

void blankoptions_selected(GtkWidget *item, gint nr) {
gint sel;

	sel = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(item));

	switch(nr) {
		case 0:
			curset.blank_force = sel;
			break;
		case 1:
			curset.blank_eject = sel;
			break;
	}
}


/* timer function for blanking */

gint blank_timer(gpointer data) {
time_t start_time;
time_t curtime;
gint secs;
char tmp[MAXLINE];

	/* how many seconds have passed since first start? */
	start_time = (time_t)data;
	curtime = time((time_t *) 0);
	secs = (gint) curtime - start_time;

	/* set new label */
	g_snprintf(tmp,MAXLINE,text(189),secs/60,secs%60);
	gtk_label_set_text(GTK_LABEL(blank_infolabel),tmp);

	return(TRUE);
}


/* called by ok-button in blank-window */

void blank_start(GtkWidget *widget, gint data) {
time_t start_time;
time_t curtime;
gint secs;
gint stat;
char tmp[MAXLINE];

	/* get current time */
	start_time = time((time_t *) 0); 
	misc_timer = gtk_timeout_add(1000, blank_timer, (gpointer) start_time);
		
	/* disable ok button */
	gtk_widget_set_sensitive(widget, FALSE);
	gtk_label_set_text(GTK_LABEL(GTK_BIN(readtrack_button)->child),T_CANCEL);

	/* clear text-window */
	gtk_text_backward_delete(GTK_TEXT(blank_text_window),
		gtk_text_get_length(GTK_TEXT(blank_text_window)));

	/* now this waits here until blanking is done */
	stat = start_blanking_process(curset.writer_devnr, blank_text_window);

	if (stat == 1) {
		/* error? */
		gtk_label_set_text(GTK_LABEL(blank_infolabel),text(191));
	} else
	if (stat == 0) {
		/* ok */
		curtime = time((time_t *) 0);
		secs = (gint) curtime - start_time;
		g_snprintf(tmp,MAXLINE,text(192),secs/60,secs%60);
		gtk_label_set_text(GTK_LABEL(blank_infolabel),tmp);
	} else {
		/* aborted */
		curtime = time((time_t *) 0);
		secs = (gint) curtime - start_time;
		g_snprintf(tmp,MAXLINE,text(193),secs/60,secs%60);
		gtk_label_set_text(GTK_LABEL(blank_infolabel),tmp);
	}
	
	if (misc_timer != 0) 
		gtk_timeout_remove(misc_timer);
	misc_timer = 0;

	/* enable ok button */
	gtk_widget_set_sensitive(widget, TRUE);
	
	/* restore close button */
	gtk_label_set_text(GTK_LABEL(GTK_BIN(readtrack_button)->child),T_CLOSE);

	dobeep(1);

}


/* called by cancel-button in blank-window */

void blank_cancel(GtkWidget *widget, gpointer data) {

	/* nothing more to here, because actual killing is handled
	   in start_blanking_process() */
	dialog_done2 = -1; 
}

gint blank_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data) {

	blank_cancel(widget,data);
        return(TRUE);
}


/* popup a modal window, set cursor to watch, return path or NULL-string 
   when cancel or delete_event found.
   Centers automatically above the toplevel-widow 
*/

void display_blank_cdrw(gint devnr) {
GtkWidget *dialog, *tbl;
GtkWidget *button1, *button2;
GtkWidget *box1,*box2,*box3,*txt;
GtkWidget *f1, *l1, *check, *sep;
GtkWidget *omenu;
GtkWidget *menu;
GtkWidget *menu_item;
GtkWidget *scrolled_win;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;
gint i, menuhistory, menuidx;

	/* if another dialog is running, ignore */
	if (dialog_done2 == 999) {
		return;
	}

	dodebug(8, "displaying display_blank_cdrw\n");

	/* mark our dialog as running */
	dialog_done2 = 999;
	misc_timer = 0;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,450,250); 
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (blank_delete_event), (gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,0);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	f1 = gtk_frame_new(text(171));
	set_font_and_color(f1,BOLDFONT,NULL);
	gtk_box_pack_start(GTK_BOX(box1),f1,TRUE,TRUE,0);
	gtk_widget_show(f1);

	box2 = gtk_vbox_new(FALSE,0);
	gtk_container_set_border_width (GTK_CONTAINER (box2), 5);
	gtk_container_add(GTK_CONTAINER(f1),box2);
	gtk_widget_show(box2);

	tbl = gtk_table_new(5, 8, FALSE);
	gtk_table_set_col_spacings(GTK_TABLE(tbl),10);
	gtk_box_pack_start(GTK_BOX(box2),tbl,FALSE,TRUE,0);
	gtk_widget_show(tbl);

	l1 = rightjust_gtk_label_new(text(185));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,0,3,0,1);
	gtk_widget_show(l1);	
	
	omenu = gtk_option_menu_new();
	menu = gtk_menu_new();
	menuidx = 0; menuhistory = 0;

	i = 0; 
	while (blankmodes[i] != NULL) {
		
		menu_item = gtk_menu_item_new_with_label(blankmodes[i]->desc);
		gtk_signal_connect(GTK_OBJECT(menu_item),
			"activate", GTK_SIGNAL_FUNC(blankmode_selected),
			(gpointer)i);
		gtk_menu_append (GTK_MENU (menu), menu_item);
		if (curset.blankmode == i) { menuhistory = menuidx; }
		menuidx++;
		gtk_widget_show (menu_item);
		i++;
	}

	gtk_option_menu_set_menu (GTK_OPTION_MENU (omenu), menu);
	gtk_option_menu_set_history(GTK_OPTION_MENU (omenu),menuhistory);
	gtk_table_attach_defaults(GTK_TABLE(tbl),omenu,3,8,0,1);
	gtk_widget_show(omenu);	

	check = gtk_check_button_new_with_label(text(186));
	gtk_signal_connect(GTK_OBJECT(check),"clicked",
		GTK_SIGNAL_FUNC(blankoptions_selected),(gpointer) 0);
	gtk_table_attach_defaults(GTK_TABLE(tbl),check,3,8,1,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check),
		curset.blank_force);
	gtk_widget_show(check);

	check = gtk_check_button_new_with_label(text(187));
	gtk_signal_connect(GTK_OBJECT(check),"clicked",
		GTK_SIGNAL_FUNC(blankoptions_selected),(gpointer) 1);
	gtk_table_attach_defaults(GTK_TABLE(tbl),check,3,8,2,3);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check),
		curset.blank_eject);
	gtk_widget_show(check);

	sep = gtk_hseparator_new();
	gtk_table_attach_defaults(GTK_TABLE(tbl),sep,0,8,3,4);
	gtk_widget_show(sep);
	
	f1 = gtk_frame_new(NULL);

	gtk_frame_set_shadow_type(GTK_FRAME(f1),GTK_SHADOW_IN);
	gtk_container_set_border_width (GTK_CONTAINER (f1), 5);
	gtk_table_attach_defaults(GTK_TABLE(tbl),f1,0,8,4,5);
	gtk_widget_show(f1);

	l1 = gtk_label_new("");
	blank_infolabel = l1;
	gtk_container_add(GTK_CONTAINER(f1),l1);
	gtk_widget_show(l1);	

	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(box2),scrolled_win);
	gtk_widget_show(scrolled_win);
	
	txt = gtk_text_new(NULL,NULL);
	blank_text_window = txt;
	gtk_text_set_editable(GTK_TEXT(txt),FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(txt),TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_win), txt);
	gtk_widget_show(txt);

	gtk_widget_show(box1);

	box3 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box3,FALSE,TRUE,5);
	gtk_widget_show(box3);

	button1 = gtk_button_new_with_label(text(171));
	gtk_box_pack_start(GTK_BOX(box3),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(blank_start), NULL);

	button2 = gtk_button_new_with_label(T_CLOSE);
	readtrack_button = button2;
	gtk_box_pack_start(GTK_BOX(box3),button2,TRUE,TRUE,10);
	gtk_widget_show(button2);
	gtk_signal_connect(GTK_OBJECT(button2),"clicked",
		GTK_SIGNAL_FUNC(blank_cancel), (gpointer) -1);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	/* now fill text-widget with infos */
	gtk_text_insert(GTK_TEXT(txt),NULL,NULL,NULL,
		text(188), strlen(text(188)));

	gtk_widget_show(dialog);


	/* now wait until button is pressed */
	while (dialog_done2 == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);
}


/* save output of write process */

void show_writetrack_save_press(GtkWidget *widget, gint data) {
char tmp[MAXLINE];

	/* show fileselector */
	show_file_selector(SAVEOUTCDRECORD,tmp);
	
	/* not cancel pressed? */
	if (strcmp(tmp,"") != 0) {
		if (save_text2file(tmp, readtrack_textview) == 0) {
			show_dialog(ICO_INFO,text(270), T_OK, NULL, NULL, 0);
		}
	}
}


/* called by cancel-button in write-window */

void write_cancel(GtkWidget *widget, gpointer data) {

	/* nothing more to here, because actual killing is handled
	   in start_write_action() */
	dialog_done2 = -1; 
}

gint write_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data) {

	write_cancel(widget,data);
        return(TRUE);
}


/* create the write-tracks-box */

gint show_and_do_write_tracks(gint devnr, gint read_devnr, gint onthefly) {
GtkWidget *omenu;
GtkWidget *menu;
GtkWidget *menu_item;
GtkWidget *dialog;
GtkWidget *l1;
GtkWidget *button1, *button2;
GtkWidget *box1,*box2,*txt;
GtkWidget *f1, *tbl;
GtkWidget *b1_sep, *lbl;
GtkWidget *scrolled_win;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;
GtkAdjustment *adj1, *adj2, *adj3;
GtkWidget *pbar1, *pbar2, *pbar3;
gint i, menuidx, menuhistory;

	/* if another dialog is running, ignore */
	if (dialog_done2 == 999) {
		return -1;
	}

	dodebug(8, "displaying show_and_do_write_tracks\n");

	/* mark our dialog as running */
	dialog_done2 = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	viewmode_dialog = dialog;
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,340,0);
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (write_delete_event), 
		(gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,5);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	f1 = gtk_frame_new(NULL);
	readtrack_info_frame = f1;
	gtk_frame_set_shadow_type(GTK_FRAME(f1),GTK_SHADOW_IN);
	gtk_widget_set_usize(f1,0,36);
	gtk_box_pack_start(GTK_BOX(box1),f1,FALSE,TRUE,5);
	if (curset.proc_view > 0) 
		gtk_widget_show(f1);

	lbl = gtk_label_new("");
	readtrack_info_label = lbl;
	gtk_container_add(GTK_CONTAINER(f1), lbl);
	gtk_misc_set_alignment(GTK_MISC(lbl),0.5,0.5);
	gtk_misc_set_padding(GTK_MISC(lbl),10,0);
	gtk_widget_show(lbl);

	tbl = gtk_table_new(3, 10, TRUE);
	readtrack_info_tbl = tbl;
	gtk_table_set_col_spacing(GTK_TABLE(tbl),1,10);
	gtk_table_set_row_spacings(GTK_TABLE(tbl),5);
	gtk_box_pack_start(GTK_BOX(box1),tbl,FALSE,TRUE,5);
	if (curset.proc_view > 0) 
		gtk_widget_show(tbl);

	l1 = rightjust_gtk_label_new(text(150));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,0,2,0,1);
	gtk_widget_show(l1);

	adj1 = (GtkAdjustment *)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
	pbar1 = gtk_progress_bar_new_with_adjustment(adj1);
	readtrack_pbar1 = pbar1;
	gtk_progress_set_format_string(GTK_PROGRESS(pbar1),"%p%%");
	gtk_progress_set_show_text(GTK_PROGRESS(pbar1),TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tbl),pbar1,2,10,0,1);
	gtk_widget_show(pbar1);

	l1 = rightjust_gtk_label_new(text(151));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,0,2,1,2);
	gtk_widget_show(l1);

	adj2 = (GtkAdjustment *)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
	pbar2 = gtk_progress_bar_new_with_adjustment(adj2);
	readtrack_pbar2 = pbar2;
	gtk_progress_set_format_string(GTK_PROGRESS(pbar2),"%p%%");
	gtk_progress_set_show_text(GTK_PROGRESS(pbar2),TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tbl),pbar2,2,10,1,2);
	gtk_widget_show(pbar2);

	l1 = rightjust_gtk_label_new(text(205));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,0,2,2,3);
	gtk_widget_show(l1);

	adj3 = (GtkAdjustment *)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
	pbar3 = gtk_progress_bar_new_with_adjustment(adj3);
	readtrack_pbar3 = pbar3;
	gtk_progress_set_format_string(GTK_PROGRESS(pbar3),"%p%%");
	gtk_progress_set_show_text(GTK_PROGRESS(pbar3),TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tbl),pbar3,2,10,2,3);
	gtk_widget_show(pbar3);

	tbl = gtk_table_new(1, 10, TRUE);
	gtk_table_set_col_spacing(GTK_TABLE(tbl),6,10);
	gtk_table_set_row_spacings(GTK_TABLE(tbl),5);
	gtk_box_pack_start(GTK_BOX(box1),tbl,FALSE,TRUE,0);
	gtk_widget_show(tbl);

	lbl = gtk_label_new("");
	readtrack_small_info = lbl;
	gtk_table_attach_defaults(GTK_TABLE(tbl),lbl,0,3,0,1);
	if (curset.proc_view == 0) 
		gtk_widget_show(lbl);

	lbl = gtk_label_new("");
	readtrack_small_info2 = lbl;
	gtk_table_attach_defaults(GTK_TABLE(tbl),lbl,3,5,0,1);
	if (curset.proc_view == 0) 
		gtk_widget_show(lbl);

	l1 = rightjust_gtk_label_new(text(152));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,5,7,0,1);
	gtk_widget_show(l1);

	omenu = gtk_option_menu_new();
	menu = gtk_menu_new();
	menuidx = 0; menuhistory = -1;

	for (i=0; i<3; i++) {
		menu_item = gtk_menu_item_new_with_label(text(153+i));
		gtk_signal_connect(GTK_OBJECT(menu_item),
			"activate", GTK_SIGNAL_FUNC(viewmode_selected),
			(gpointer)i);
		gtk_menu_append (GTK_MENU (menu), menu_item);
		if (curset.proc_view == i) { menuhistory = menuidx; }
		menuidx++;
		gtk_widget_show (menu_item);
	}
	gtk_option_menu_set_menu (GTK_OPTION_MENU (omenu), menu);
	if (menuhistory != -1) {
		gtk_option_menu_set_history(GTK_OPTION_MENU (omenu),menuhistory);
	} else {
		curset.proc_view = 1;
		gtk_option_menu_set_history(GTK_OPTION_MENU (omenu),1);
	}
	gtk_table_attach_defaults(GTK_TABLE(tbl),omenu,7,10,0,1);
	gtk_widget_show(omenu);

	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	viewmode_scrolled = scrolled_win;
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(box1),scrolled_win,TRUE,TRUE,0);

	/* show only in extended view */
	if (curset.proc_view == 2) 
		gtk_widget_show(scrolled_win);

	txt = gtk_text_new(NULL,NULL);
	readtrack_textview = txt;
	gtk_text_set_editable(GTK_TEXT(txt),FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(txt),TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_win), txt);
	gtk_widget_show(txt);

	gtk_widget_show(box1);

	b1_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1),b1_sep,FALSE,TRUE,0);
	gtk_widget_show(b1_sep);

	box2 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,10);
	gtk_widget_show(box2);

	button1 = gtk_button_new_with_label(T_CANCEL);
	readtrack_button = button1;
	gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (button1);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(write_cancel), (gpointer) -1);

	button2 = gtk_button_new_with_label(text(162));
	readtrack_savebutton = button2;
	gtk_box_pack_start(GTK_BOX(box2),button2,TRUE,TRUE,10);
	GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(button2),"clicked",
		GTK_SIGNAL_FUNC(show_writetrack_save_press), (gpointer) -1);
	/* show only in extended view */
	if (curset.proc_view == 2) 
		gtk_widget_show(button2);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	gtk_widget_show(dialog);

	/* here is the action */
	if (onthefly == 0) {
		start_write_action(devnr); 
	} else {
		start_write_onthefly_action(read_devnr, devnr);
	}

	/* when done with reading rename button to OK */
	gtk_label_set_text(GTK_LABEL(GTK_BIN(readtrack_button)->child),T_OK);

	dobeep(1);
	
	/* now wait until button is pressed */
	while (dialog_done2 == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);

	return dialog_done2;
}


/* called by cancel-button in delete-window */

void delete_cancel(GtkWidget *widget, gpointer data) {

	/* delete running? */
	if (read_done == 999) {
		/* abort */
		kill_readcdda();
	} else {
		dialog_done2 = -1; 
	}
}

gint delete_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data) {

	write_cancel(widget,data);
        return(TRUE);
}


/* display a menu and do delete tracks */

gint show_and_do_delete(GList *delfiles) {
GtkWidget *dialog;
GtkWidget *button1;
GtkWidget *box1,*box2;
GtkWidget *f1;
GtkWidget *b1_sep, *lbl;
GtkWidget *scrolled_win, *txt;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;
GtkAdjustment *adj1;
GtkWidget *pbar1;


	/* if another dialog is running, ignore */
	if (dialog_done2 == 999) {
		return -1;
	}

	dodebug(8, "displaying show_and_do_delete\n");

	/* mark our dialog as running */
	dialog_done2 = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	viewmode_dialog = dialog;
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,340,0);
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (delete_delete_event), 
		(gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,5);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);
	gtk_widget_show(box1);

	f1 = gtk_frame_new(NULL);
	readtrack_info_frame = f1;
	gtk_frame_set_shadow_type(GTK_FRAME(f1),GTK_SHADOW_IN);
	gtk_widget_set_usize(f1,0,36);
	gtk_box_pack_start(GTK_BOX(box1),f1,FALSE,TRUE,5);
	gtk_widget_show(f1);

	lbl = gtk_label_new("");
	readtrack_info_label = lbl;
	gtk_container_add(GTK_CONTAINER(f1), lbl);
	gtk_misc_set_alignment(GTK_MISC(lbl),0.5,0.5);
	gtk_misc_set_padding(GTK_MISC(lbl),10,0);
	gtk_widget_show(lbl);

	adj1 = (GtkAdjustment *)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
	pbar1 = gtk_progress_bar_new_with_adjustment(adj1);
	readtrack_pbar1 = pbar1;
	gtk_progress_set_format_string(GTK_PROGRESS(pbar1),"%p%%");
	gtk_progress_set_show_text(GTK_PROGRESS(pbar1),TRUE);
	gtk_box_pack_start(GTK_BOX(box1),pbar1,FALSE,TRUE,5);
	gtk_widget_show(pbar1);

	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(box1),scrolled_win);
	gtk_widget_show(scrolled_win);

	txt = gtk_text_new(NULL,NULL);
	readtrack_textview = txt;
	gtk_text_set_editable(GTK_TEXT(txt),FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(txt),TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_win), txt);
	gtk_widget_show(txt);
	
	b1_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1),b1_sep,FALSE,TRUE,0);
	gtk_widget_show(b1_sep);

	box2 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,10);
	gtk_widget_show(box2);

	button1 = gtk_button_new_with_label(T_CANCEL);
	readtrack_button = button1;
	gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (button1);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(delete_cancel), (gpointer) -1);

	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	gtk_widget_show(dialog);

	/* here is the action */
	start_delete_action(delfiles);

	/* when done with delete rename button to OK */
	gtk_label_set_text(GTK_LABEL(GTK_BIN(readtrack_button)->child),T_OK);
	
	/* now wait until button is pressed */
	while (dialog_done2 == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);

	return dialog_done2;
}


/* start the read-processes according to the trackreadset-struct.
   Update verify-dialogbox and return 0 if ok, 1 on error */ 

gint start_verify_action(gint read_devnr) {
GList *loop;
track_read_param_t *trackparam;
gfloat percent_done;
gint stat;
gint errcount;

	dolog(1, "Verify CD with toc file %s\n", trackreadset.tocfile);

	percent_done = 0;
	errcount = 0;

	/* start verifying all tracks */
	loop = g_list_first(trackreadset.trackparams);
	while (loop) {
		trackparam = loop->data;
		
		/* data-track */
		if (trackparam->tracktype == 0) {
			stat = verify_data_track(read_devnr,
				trackparam->starttrack,
				trackparam->kbyte,
				trackparam->trackfile,
				trackparam->startoffset,	
				trackparam->endoffset,
				trackreadset.nrtracks,				
				trackparam->percent,
				percent_done);
			percent_done += trackparam->percent;
		} else {
		/* audio-track */
			if (curset.noaudioverify == 0) {
				stat = verify_audio_track(read_devnr,
					trackparam->starttrack,
					trackparam->endtrack,
					trackparam->kbyte,
					trackparam->trackfile,
					trackparam->startoffset,
					trackparam->endoffset,
					trackreadset.nrtracks,	
					trackparam->percent,
					percent_done);
				percent_done += trackparam->percent;
			} else {
				/* we dont want to verify audio */
				stat = 0;
			}
		}
		if (stat == 2) {
			/* user abort */
			return 1;
		}
		if (stat != 0) {
			/* error while reading */
			if (curset.verifyfailabort == 1)
				return 1;
			errcount++;
		}
		loop = loop->next;
	}

	/* if we only got a single error we failed */
	if (errcount > 0) {
		return 1;
	}
	/* no error verifying tracks */
	gtk_label_set_text(GTK_LABEL(readtrack_info_label), text(243));
	gtk_label_set_text(GTK_LABEL(readtrack_small_info), text(165));

	return 0;
}


/* called from cancel or ok button */
 
void show_verifytrack_btn_press(GtkWidget *widget, gint data) {

	/* read-process running? */
	if (read_done == 999) {
		/* mark aborted */
		read_abort_mark = 1;
		/* abort our read-process */
		kill_readcdda();
		return;
	}

	/* cancel event */
	if (data == -1) {
		dialog_done = -1;
		return;
	}
}


void show_verifytrack_save_press(GtkWidget *widget, gint data) {
char tmp[MAXLINE];

	/* show fileselector */
	show_file_selector(SAVEVERIFYTRACKS,tmp);
	
	/* not cancel pressed? */
	if (strcmp(tmp,"") != 0) {
		if (save_text2file(tmp, readtrack_textview) == 0) {
			show_dialog(ICO_INFO,text(270), T_OK, NULL, NULL, 0);
		}
	}
}

gint verifytrack_dialog_delete_event(GtkWidget *widget, GdkEvent *event, 
	gpointer data) {

	/* read-process running? */
	if (read_done == 999) {
		/* mark aborted */
		read_abort_mark = 1;
		/* abort our read-process */
		kill_readcdda();
		return(TRUE);
	}

	dialog_done = -1;
        return(TRUE);
}


/* popup a modal window, set cursor to watch, trigger read tracks 
   and return 0 if all ok, -1 if not or 
   when cancel or delete_event found.
   Centers automatically above the toplevel-widow 
*/

gint show_and_do_verify_tracks(gint devnr) {
GtkWidget *omenu;
GtkWidget *menu;
GtkWidget *menu_item;
GtkWidget *dialog;
GtkWidget *l1;
GtkWidget *button1, *button2;
GtkWidget *box1,*box2,*txt;
GtkWidget *f1, *tbl;
GtkWidget *b1_sep, *lbl;
GtkWidget *scrolled_win;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;
GtkAdjustment *adj1, *adj2;
GtkWidget *pbar1, *pbar2;
gint i, menuidx, menuhistory;

	/* if another dialog is running, ignore */
	if (dialog_done == 999) {
		return -1;
	}

	dodebug(8, "displaying show_and_do_verify_tracks\n");

	/* mark our dialog as running */
	dialog_done = 999;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	viewmode_dialog = dialog;
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,340,0);
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (verifytrack_dialog_delete_event), 
		(gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,5);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	f1 = gtk_frame_new(NULL);
	readtrack_info_frame = f1;
	gtk_frame_set_shadow_type(GTK_FRAME(f1),GTK_SHADOW_IN);
	gtk_widget_set_usize(f1,0,36);
	gtk_box_pack_start(GTK_BOX(box1),f1,FALSE,TRUE,5);
	if (curset.proc_view > 0) 
		gtk_widget_show(f1);

	lbl = gtk_label_new("");
	readtrack_info_label = lbl;
	gtk_container_add(GTK_CONTAINER(f1), lbl);
	gtk_misc_set_alignment(GTK_MISC(lbl),0.5,0.5);
	gtk_misc_set_padding(GTK_MISC(lbl),10,0);
	gtk_widget_show(lbl);

	tbl = gtk_table_new(2, 10, TRUE);
	readtrack_info_tbl = tbl;
	gtk_table_set_col_spacing(GTK_TABLE(tbl),1,10);
	gtk_table_set_row_spacings(GTK_TABLE(tbl),5);
	gtk_box_pack_start(GTK_BOX(box1),tbl,FALSE,TRUE,5);
	if (curset.proc_view > 0) 
		gtk_widget_show(tbl);

	l1 = rightjust_gtk_label_new(text(150));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,0,2,0,1);
	gtk_widget_show(l1);

	adj1 = (GtkAdjustment *)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
	pbar1 = gtk_progress_bar_new_with_adjustment(adj1);
	readtrack_pbar1 = pbar1;
	gtk_progress_set_format_string(GTK_PROGRESS(pbar1),"%p%%");
	gtk_progress_set_show_text(GTK_PROGRESS(pbar1),TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tbl),pbar1,2,10,0,1);
	gtk_widget_show(pbar1);

	l1 = rightjust_gtk_label_new(text(151));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,0,2,1,2);
	gtk_widget_show(l1);

	adj2 = (GtkAdjustment *)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
	pbar2 = gtk_progress_bar_new_with_adjustment(adj2);
	readtrack_pbar2 = pbar2;
	gtk_progress_set_format_string(GTK_PROGRESS(pbar2),"%p%%");
	gtk_progress_set_show_text(GTK_PROGRESS(pbar2),TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tbl),pbar2,2,10,1,2);
	gtk_widget_show(pbar2);

	tbl = gtk_table_new(1, 10, TRUE);
	gtk_table_set_col_spacing(GTK_TABLE(tbl),6,10);
	gtk_table_set_row_spacings(GTK_TABLE(tbl),5);
	gtk_box_pack_start(GTK_BOX(box1),tbl,FALSE,TRUE,0);
	gtk_widget_show(tbl);

	lbl = gtk_label_new("");
	readtrack_small_info = lbl;
	gtk_table_attach_defaults(GTK_TABLE(tbl),lbl,0,3,0,1);
	if (curset.proc_view == 0) 
		gtk_widget_show(lbl);

	lbl = gtk_label_new("");
	readtrack_small_info2 = lbl;
	gtk_table_attach_defaults(GTK_TABLE(tbl),lbl,3,5,0,1);
	if (curset.proc_view == 0) 
		gtk_widget_show(lbl);

	l1 = rightjust_gtk_label_new(text(152));
	gtk_table_attach_defaults(GTK_TABLE(tbl),l1,5,7,0,1);
	gtk_widget_show(l1);

	omenu = gtk_option_menu_new();
	menu = gtk_menu_new();
	menuidx = 0; menuhistory = -1;

	for (i=0; i<3; i++) {
		menu_item = gtk_menu_item_new_with_label(text(153+i));
		gtk_signal_connect(GTK_OBJECT(menu_item),
			"activate", GTK_SIGNAL_FUNC(viewmode_selected),
			(gpointer)i);
		gtk_menu_append (GTK_MENU (menu), menu_item);
		if (curset.proc_view == i) { menuhistory = menuidx; }
		menuidx++;
		gtk_widget_show (menu_item);
	}
	gtk_option_menu_set_menu (GTK_OPTION_MENU (omenu), menu);
	if (menuhistory != -1) {
		gtk_option_menu_set_history(GTK_OPTION_MENU (omenu),menuhistory);
	} else {
		curset.proc_view = 1;
		gtk_option_menu_set_history(GTK_OPTION_MENU (omenu),1);
	}
	gtk_table_attach_defaults(GTK_TABLE(tbl),omenu,7,10,0,1);
	gtk_widget_show(omenu);

	scrolled_win = gtk_scrolled_window_new (NULL, NULL);
	viewmode_scrolled = scrolled_win;
	gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(box1),scrolled_win,TRUE,TRUE,0);

	/* show only in extended view */
	if (curset.proc_view == 2) 
		gtk_widget_show(scrolled_win);

	txt = gtk_text_new(NULL,NULL);
	readtrack_textview = txt;
	gtk_text_set_editable(GTK_TEXT(txt),FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(txt),TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_win), txt);
	gtk_widget_show(txt);

	gtk_widget_show(box1);

	b1_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1),b1_sep,FALSE,TRUE,0);
	gtk_widget_show(b1_sep);

	box2 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box2,FALSE,TRUE,10);
	gtk_widget_show(box2);

	button1 = gtk_button_new_with_label(T_CANCEL);
	readtrack_button = button1;
	gtk_box_pack_start(GTK_BOX(box2),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
	gtk_widget_grab_default (button1);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(show_verifytrack_btn_press), (gpointer) -1);

	button2 = gtk_button_new_with_label(text(162));
	readtrack_savebutton = button2;
	gtk_box_pack_start(GTK_BOX(box2),button2,TRUE,TRUE,10);
	GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(button2),"clicked",
		GTK_SIGNAL_FUNC(show_verifytrack_save_press), (gpointer) -1);
	/* show only in extended view */
	if (curset.proc_view == 2) 
		gtk_widget_show(button2);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	gtk_widget_show(dialog);

	/* here is the action */
	start_verify_action(devnr);

	/* when done with reading rename button to OK */
	gtk_label_set_text(GTK_LABEL(GTK_BIN(readtrack_button)->child),T_OK);

	dobeep(1);
	
	/* now wait until button is pressed */
	while (dialog_done == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);

	return dialog_done;
}


/* called by buttons in dsptest-window */

void dsptest_start(GtkWidget *widget, gpointer data) {

	test_dspdevice_play();
}

void dsptest_cancel(GtkWidget *widget, gpointer data) {

	dialog_done2 = -1; 
}

gint dsptest_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data) {

	dsptest_cancel(widget,data);
        return(TRUE);
}


/* popup a modal window, set cursor to watch, return 0 if correct
   data was received from cddb-server, -1 if not or 
   when cancel or delete_event found.
   Centers automatically above the toplevel-widow 
*/

void show_setup_dsptest() {
GtkWidget *dialog;
GtkWidget *button1, *button2;
GtkWidget *box1,*box2,*box3,*txt;
GtkWidget *f1;
gint xpos, ypos;
gint xsize, ysize;
GdkCursor *cursor,*normal_cursor;
GtkRequisition rq;
GdkWindowAttr *win_attr;

	/* if another dialog is running, ignore */
	if (dialog_done2 == 999) {
		return;
	}

	dodebug(8, "displaying show_setup_dsptest\n");

	/* mark our dialog as running */
	dialog_done2 = 999;
	misc_timer = 0;

	/* create new window and position it relative to the main window */
        dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog),text(2));
	gtk_widget_set_usize(dialog,400,160); 
	/* make sure our window is always on top */
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(toplevel));

        gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
                GTK_SIGNAL_FUNC (dsptest_delete_event), (gpointer) dialog);

	/* create layout for dialog */
        box1 = gtk_vbox_new(FALSE,0);
	gtk_container_set_border_width (GTK_CONTAINER (box1), 5);
        gtk_container_add(GTK_CONTAINER(dialog),box1);

	f1 = gtk_frame_new(text(273));
	set_font_and_color(f1,BOLDFONT,NULL);
	gtk_box_pack_start(GTK_BOX(box1),f1,TRUE,TRUE,0);
	gtk_widget_show(f1);

	box2 = gtk_vbox_new(FALSE,0);
	gtk_container_set_border_width (GTK_CONTAINER (box2), 5);
	gtk_container_add(GTK_CONTAINER(f1),box2);
	gtk_widget_show(box2);


	txt = gtk_text_new(NULL,NULL);
	blank_text_window = txt;
	gtk_text_set_editable(GTK_TEXT(txt),FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(txt),TRUE);
	gtk_box_pack_start(GTK_BOX(box2),txt,TRUE,TRUE,0);
	gtk_widget_show(txt);

	gtk_widget_show(box1);

	box3 = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(box1),box3,FALSE,TRUE,5);
	gtk_widget_show(box3);

	button1 = gtk_button_new_with_label(text(274));
	gtk_box_pack_start(GTK_BOX(box3),button1,TRUE,TRUE,10);
	gtk_widget_show(button1);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
		GTK_SIGNAL_FUNC(dsptest_start), NULL);

	button2 = gtk_button_new_with_label(T_CLOSE);
	readtrack_button = button2;
	gtk_box_pack_start(GTK_BOX(box3),button2,TRUE,TRUE,10);
	gtk_widget_show(button2);
	gtk_signal_connect(GTK_OBJECT(button2),"clicked",
		GTK_SIGNAL_FUNC(dsptest_cancel), (gpointer) -1);


	/* grab cursor and change to watch */
        gtk_grab_add(dialog);
	gdk_window_get_user_data(GTK_WIDGET(toplevel)->window,
			(gpointer) &win_attr);
	normal_cursor = win_attr->cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,cursor);

	/* only center window when toplevel visible */
	if ( GTK_WIDGET_VISIBLE(toplevel)) {
        	gtk_window_position(GTK_WINDOW(dialog),GTK_WIN_POS_NONE);
        	gdk_window_get_origin(GTK_WIDGET(toplevel)->window,&xpos,&ypos);
        	gdk_window_get_size(GTK_WIDGET(toplevel)->window,&xsize,&ysize);
		gtk_widget_size_request(dialog,&rq);
        	gtk_widget_set_uposition(GTK_WIDGET(dialog),xpos+xsize/2-rq.width/2,ypos+ysize/2-rq.height/2);
	}

	/* now fill text-widget with infos */
	gtk_text_insert(GTK_TEXT(txt),NULL,NULL,NULL,
		text(275), strlen(text(275)));

	gtk_widget_show(dialog);


	/* now wait until button is pressed */
	while (dialog_done2 == 999) {
		wait_and_process_events();
	}

        gtk_grab_remove(GTK_WIDGET(dialog));
        gdk_window_set_cursor(GTK_WIDGET(toplevel)->window,normal_cursor);

	/* remove dialog window */
        gtk_widget_destroy(dialog);
}

